/**
 * This class was created by <Vazkii>. It's distributed as
 * part of the Botania Mod. Get the Source Code in github:
 * https://github.com/Vazkii/Botania
 * <p>
 * Botania is Open Source and distributed under the
 * Botania License: http://botaniamod.net/license.php
 */
package reborncore.client.multiblock;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.BlockRendererDispatcher;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;
import net.minecraftforge.client.event.RenderWorldLastEvent;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.event.world.BlockEvent;
import net.minecraftforge.event.world.WorldEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import reborncore.client.multiblock.component.MultiblockComponent;
import reborncore.common.misc.Location;
import reborncore.common.multiblock.CoordTriplet;

public class MultiblockRenderEvent
{

	private static BlockRendererDispatcher blockRender = Minecraft.func_71410_x().func_175602_ab();
	public MultiblockSet currentMultiblock;
	public static CoordTriplet anchor;
	public Location partent;
	public static int angle;

	public void setMultiblock(MultiblockSet set)
	{
		currentMultiblock = set;
		anchor = null;
		angle = 0;
		partent = null;
	}

	@SubscribeEvent
	public void onWorldRenderLast(RenderWorldLastEvent event)
	{
		Minecraft mc = Minecraft.func_71410_x();
		if (mc.field_71439_g != null && mc.field_71476_x != null && !mc.field_71439_g.func_70093_af())
		{
			mc.field_71439_g.func_184586_b(EnumHand.MAIN_HAND);
			renderPlayerLook(mc.field_71439_g, mc.field_71476_x);
		}
	}

	@SubscribeEvent
	public void onPlayerInteract(PlayerInteractEvent event)
	{
//		if (currentMultiblock != null && anchor == null && event.getAction() == Action.RIGHT_CLICK_BLOCK
//				&& event.getEntityPlayer() == Minecraft.getMinecraft().thePlayer)
//		{
//			anchor = new CoordTriplet(event.getPos());
//			angle = MathHelper.floor_double(event.getEntityPlayer().rotationYaw * 4.0 / 360.0 + 0.5) & 3;
//			event.setCanceled(true);
//		}
	}

	private void renderPlayerLook(EntityPlayer player, RayTraceResult src)
	{
		if (currentMultiblock != null)
		{
			int anchorX = anchor != null ? anchor.x : src.func_178782_a().func_177958_n();
			int anchorY = anchor != null ? anchor.y + 1 : src.func_178782_a().func_177956_o() + 1;
			int anchorZ = anchor != null ? anchor.z : src.func_178782_a().func_177952_p();

			Multiblock mb = currentMultiblock.getForEntity(player);
			for (MultiblockComponent comp : mb.getComponents())
				renderComponent(player.field_70170_p, mb, comp, anchorX, anchorY, anchorZ);
		}
	}

	private boolean renderComponent(World world, Multiblock mb, MultiblockComponent comp, int anchorX, int anchorY,
			int anchorZ)
	{
		// CoordTriplet pos = comp.getRelativePosition();
		// int x = pos.x + anchorX;
		// int y = pos.y + anchorY;
		// int z = pos.z + anchorZ;
		//
		// if (world.getBlockState(new BlockPos(x, y, z)) == comp.getBlock())
		// return false;
		//
		// GL11.glPushMatrix();
		// GL11.glEnable(GL11.GL_BLEND);
		// GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		// GL11.glDisable(GL11.GL_DEPTH_TEST);
		// GL11.glColor4f(1F, 1F, 1F, 0.4F);
		// //GL11.glTranslated(x + 0.5 - RenderManager.renderPosX, y + 0.5 -
		// RenderManager.renderPosY, z + 0.5 - RenderManager.renderPosZ);
		// Minecraft.getMinecraft().renderEngine.bindTexture(TextureMap.locationBlocksTexture);
		//
		// Block block = comp.getBlock();
		// if (IMultiblockRenderHook.renderHooks.containsKey(block))
		// IMultiblockRenderHook.renderHooks.get(block).renderBlockForMultiblock(world,
		// mb, block, comp.getMeta(), blockRender);
		// else
		// blockRender.renderBlock(block.getDefaultState(), new BlockPos(x, y,
		// z), world, Tessellator.getInstance().getWorldRenderer());
		// GL11.glEnable(GL11.GL_DEPTH_TEST);
		// GL11.glPopMatrix();
		return true;
	}

	@SubscribeEvent
	public void breakBlock(BlockEvent.BreakEvent event)
	{
		if (partent != null)
		{
			if (event.getPos().func_177958_n() == partent.x && event.getPos().func_177956_o() == partent.y && event.getPos().func_177952_p() == partent.z
					&& Minecraft.func_71410_x().field_71441_e == partent.world)
			{
				setMultiblock(null);
			}
		}
	}

	@SubscribeEvent
	public void worldUnloaded(WorldEvent.Unload event)
	{
		setMultiblock(null);
	}
}
