package reborncore.client.texture;

import net.minecraft.client.renderer.texture.AbstractTexture;
import net.minecraft.client.renderer.texture.TextureUtil;
import net.minecraft.client.resources.IResource;
import net.minecraft.client.resources.IResourceManager;
import net.minecraft.client.resources.data.IMetadataSection;
import net.minecraft.util.ResourceLocation;
import org.apache.commons.io.IOUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

/**
 * Created by Mark on 25/03/2016.
 */
public class FileSystemTexture extends AbstractTexture
{
	private static final Logger logger = LogManager.getLogger();
	protected final File textureLocation;
	BufferedImage image;

	public FileSystemTexture(File textureResourceLocation)
	{
		this.textureLocation = textureResourceLocation;
	}

	public void func_110551_a(IResourceManager resourceManager) throws IOException
	{
		this.func_147631_c();
		if(image == null){
			IResource iresource = null;
			try
			{
				iresource = new IResource()
				{

					FileInputStream stream;

					@Override
					public ResourceLocation func_177241_a()
					{
						return new ResourceLocation("reborncore:loaded/" + textureLocation.getName());
					}

					@Override
					public InputStream func_110527_b()
					{
						if(stream == null){
							try
							{
								stream = new FileInputStream(textureLocation);
							} catch (FileNotFoundException e)
							{
								e.printStackTrace();
							}
						}
						return stream;
					}

					@Override
					public boolean func_110528_c()
					{
						return false;
					}

					@Override
					public <T extends IMetadataSection> T func_110526_a(String sectionName)
					{
						return null;
					}

					@Override
					public String func_177240_d()
					{
						return "reborncore";
					}

					@Override
					public void close() throws IOException
					{
						if(stream != null){
							stream.close();
						}
					}
				};
				image= TextureUtil.func_177053_a(iresource.func_110527_b());
			} finally
			{
				IOUtils.closeQuietly(iresource);
			}
		}
		TextureUtil.func_110989_a(this.func_110552_b(), image, false, false);
	}
}
