package reborncore.common.util;

import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;
import net.minecraftforge.event.entity.player.FillBucketEvent;
import net.minecraftforge.fluids.BlockFluidBase;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fml.common.eventhandler.Event;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

import java.util.HashMap;
import java.util.Map;

public class BucketHandler
{

	public static BucketHandler INSTANCE = new BucketHandler();
	public Map<Fluid, Item> buckets = new HashMap<>();

	private BucketHandler()
	{

	}

	@SubscribeEvent public void onBucketFill(FillBucketEvent event)
	{
		ItemStack result = fillCustomBucket(event.getWorld(), event.getTarget());

		if (result == null)
			return;

		event.setFilledBucket(result);
		event.setResult(Event.Result.ALLOW);
	}

	private ItemStack fillCustomBucket(World world, RayTraceResult pos)
	{
		if (pos != null && pos.func_178782_a() != null && world.func_180495_p(pos.func_178782_a()) != null) {
			Block block = world.func_180495_p(pos.func_178782_a()).func_177230_c();
			if(block instanceof BlockFluidBase){
				Fluid fluid = ((BlockFluidBase) block).getFluid();
				if(buckets.containsKey(fluid)){
					Item bucket = buckets.get(fluid);
					if (bucket != null) {
						world.func_175698_g(pos.func_178782_a());
						return new ItemStack(bucket, 1);
					}
				}
			}
		}
		return null;
	}

}
