package reborncore.shields.client;

import net.minecraft.client.Minecraft;
import net.minecraft.client.model.ModelShield;
import net.minecraft.client.renderer.BannerTextures;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.texture.AbstractTexture;
import net.minecraft.client.renderer.tileentity.TileEntityItemStackRenderer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntityBanner;
import net.minecraft.util.ResourceLocation;
import reborncore.common.util.ItemNBTHelper;
import reborncore.shields.json.ShieldJsonLoader;
import reborncore.shields.json.ShieldUser;

import java.util.HashMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

/**
 * Created by Mark on 21/03/2016.
 */
public class RebornItemStackRenderer extends TileEntityItemStackRenderer {

    private TileEntityBanner banner = new TileEntityBanner();
    private ModelShield modelShield = new ModelShield();

    private HashMap<String, AbstractTexture> customTextureMap = new HashMap<>();
    private static final ExecutorService THREAD_POOL = new ThreadPoolExecutor(0, 2, 1L, TimeUnit.MINUTES, new LinkedBlockingQueue());

    TileEntityItemStackRenderer renderer;

    public RebornItemStackRenderer(TileEntityItemStackRenderer renderer) {
        this.renderer = renderer;
    }

    @Override
    public void func_179022_a(ItemStack itemStackIn) {
        if (itemStackIn.func_77973_b() == Items.field_185159_cQ) {
            boolean isCustom = !ItemNBTHelper.getBoolean(itemStackIn, "vanilla", false);
             if (isCustom) {
                ResourceLocation location = null;
                String str = ItemNBTHelper.getString(itemStackIn, "type", "vanilla");
                 if(ShieldJsonLoader.shieldJsonFile == null || ShieldJsonLoader.shieldJsonFile.userList == null){
                     renderer.func_179022_a(itemStackIn);
                     return;
                 }
                for (ShieldUser user : ShieldJsonLoader.shieldJsonFile.userList) {
                    if (user.username.equalsIgnoreCase(str)) {
                        location = new ResourceLocation("LOOKUP:" + str);
                    }
                }
                 if(location == null){
                     renderer.func_179022_a(itemStackIn);
                     return;
                 }
                ShieldTexture shieldTexture = ShieldTextureStore.getTexture(location);
                if (shieldTexture != null) {
                    if (shieldTexture.getState() == DownloadState.DOWNLOADED) {
                        if (customTextureMap.containsKey(location.func_110623_a())) {
                            Minecraft.func_71410_x().func_110434_K().func_110577_a(location);
                        } else {
                            AbstractTexture texture = shieldTexture.getTexture();
                            customTextureMap.put(location.func_110623_a(), texture);
                            //TODO make this even more threaded to stop the game stalling
                            final ResourceLocation resourceLocation = location;
                            THREAD_POOL.submit((Runnable) () -> Minecraft.getMinecraft().addScheduledTask((Runnable) () -> Minecraft.getMinecraft().getTextureManager().loadTexture(resourceLocation, texture)));
                            Minecraft.func_71410_x().func_110434_K().func_110577_a(BannerTextures.field_187486_c);
                        }
                    } else {
                        Minecraft.func_71410_x().func_110434_K().func_110577_a(BannerTextures.field_187486_c);
                    }
                } else {
                    Minecraft.func_71410_x().func_110434_K().func_110577_a(BannerTextures.field_187486_c);
                }
            } else {
                 renderer.func_179022_a(itemStackIn);
                 return;
             }
            GlStateManager.func_179094_E();
            GlStateManager.func_179152_a(1.0F, -1.0F, -1.0F);
            modelShield.func_187062_a();
            GlStateManager.func_179121_F();
            return;
        }
        renderer.func_179022_a(itemStackIn);

    }
}
